
; This part defines all the variables
directed-link-breed [blue-links blue-link]
turtles-own [min-incomming-cost max-incomming-cost total-incomming-cost std-incomming-cost surplus-given-antioch surplus-given-ephesus ephesus-receipt i-ephesus-demand i-ephesus-demand-from-myself ephesus-demand-on-me my-surplus-given-ephesus my-surplus-given-ephesus-old antioch-receipt i-antioch-demand i-antioch-demand-from-myself antioch-demand-on-me my-surplus-given-antioch my-surplus-given-antioch-old rome-receipt i-rome-demand i-rome-demand-from-myself rome-demand-on-me my-surplus-given-rome my-surplus-given-rome-old surplus-given-rome my-surplus-given surplus-given my-surplus-given-old prelim-size cum_demand_on_me transport-cost my-transport-cost-old my-transport-cost i-demand-from-myself cost-to-blue-in-links min-cost-to-blue-link cost-to-blue-node my-cost-to-blue my-cost-from-blue my-surplus-proportion my-prop-surplus-cost total-demand-cost cost-to-red-in-links min-cost-to-red-link min-cost-from-blue-link total-surplus-cost surplus-out-links demand-out-links reverse-sort-out-links my-surplus-cost my-demand-proportion my-prop-demand-cost my-demand-cost node-id demand my-receipt surplus-check demand-check surplus-out-node demand-out-node sort-cost-from-blue-out-links cost-from-blue-out-links cost-from-blue-out-bogey-link cost-from-blue-out-bogey-node sort-cost-to-red-out-links cost-to-red-out-links cost-to-red-out-bogey-link cost-to-red-out-bogey-node sort-surplus-out-links demand-out-bogey-link surplus-out-bogey-link demand-out-bogey-node surplus-out-bogey-node sort-demand-out-links cost-from-blue-in-links sort-in-links sort-out-links sort-demand-in-links sort-surplus-in-links reverse-cost-from-blue reverse-cost-to-red i-demand-new i-surplus-new my-receipt-new demand-on-me-new i-surplus val-i-give demand-on-me i-demand val-time-1 surplus-in-links demand-in-links my-cost-to-red val new-val  val-last]; 
links-own [cost1 cumulative-demand-flow-ephesus demand-flow-ephesus-old my-demand-flow-ephesus demand-flow-ephesus cumulative-demand-flow-antioch demand-flow-antioch-old my-demand-flow-antioch demand-flow-antioch cumulative-demand-flow-rome demand-flow-rome-old my-demand-flow-rome demand-flow-rome cumulative-demand-flow demand-flow-old my-demand-flow cost-to-blue other-end-min-cost d_bogey s_bogey other-end-bogey surplus-flow demand-flow other-end-demand other-end-surplus other-end-blue other-end-red link_id_1 link_id_2 cost-to-red cost-from-blue cost proportion-demand proportion-surplus ]  ; the amount of quantity that has passed through a link
patches-own [ value]
extensions [ gis gradient]        



globals [
  val-list
  cost-list
  raster
  total-size
  landsea-clip
  points
  total-production
  total-consumption
  network-demand
  network-surplus
  total-val                 ; total quantity in the system
  max-val
  min-flow                   ; maximum quantity held by a single node in the system
  mean-flow                  ; maximum quantity that has passed through a link in the system                 ; average quantity that is passing through an arbitrary
  links-list 
  booba
  total-transport-cost
  total-demand-flow
  total-surplus-given
  mean-cum-flow
  total-consumption-old
  total-production-old
  total-consumed
  total-consumed-total
  total-exported
  total-exported-total
  lost-in-transport
]

;;;;;;;;;;;;;;;;;;;;;;;;
;;; Setup Procedures ;;;
;;;;;;;;;;;;;;;;;;;;;;;;

 to setup
   clear-all

  import-GIS-data
  set-default-shape turtles "circle"
  
  ;Import your file here
  
  import-gis-cities
  add_chandler_data
  import-roman-roads

  ask turtles [
 
      if val > 1000 [set color blue]
      if val < -1000 [set color red] 
      if (val > -1000) and (val < 1000) [
        
        
        if count my-in-links = 2 [        
        set color black]
        if count my-in-links > 2[
          set color orange]]
      

    
      if not any? in-link-neighbors and not any? out-link-neighbors [ set color green]
      set my-cost-to-red 0
      set my-cost-from-blue 0
      ask my-out-links [set cost-to-red 0]
      ask my-out-links [set cost-from-blue 0]
      set my-receipt 0
      set demand 0]
      
      
      ask turtles [ if color = black [ if (count in-link-neighbors) + (count out-link-neighbors) = 1 [ set color green ]]]
      ask turtles with [color = red ] [set my-transport-cost 0]
      ask links [ set my-demand-flow 0]
      
      ask turtles with [color = orange] [hide-turtle]
      ask turtles with [color = black] [hide-turtle]

   
   


  reset-ticks
  
  
end 
;----------------------------------------------------------------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------------------------------------------------------------
; This is where we import the GIS data that is located in the same folder. 


to import-GIS-data
  ca 
  gis:load-coordinate-system "cities.prj"  ;The map projection
  set raster gis:load-dataset "population.asc" ; The population raster
  set points gis:load-dataset "cities.shp" ;Our cities shapefile with the associated surplus and deficit values.
  
  resize-world 0 gis:width-of raster 0 gis:height-of raster 
      gis:set-world-envelope  (gis:envelope-of raster)

  gis:apply-raster raster value
  let min-value gis:minimum-of raster
  let max-value gis:maximum-of raster
  
  ; Set the colors for the map
  ask patches
  
   [ ifelse (value <= 0) or (value >= 0)
;    [ set pcolor gradient:scale [[ 0 102 0 ] [255 153 0]]  value -300000 500000 ]
;    [ set pcolor [ 0 102 0 ] ]
     [ set pcolor  63 ]
    [ set pcolor 87] 
    
    if ((is-number? value ) =  false )
    [set pcolor 20]]
   
;  [ ifelse (value <= 0) or (value >= 0)
;    [ set pcolor gradient:scale [[ 0 102 0 ] [255 153 0]]  value 1 2500 ]
;    [ set pcolor 87] 
;    if ((is-number? value ) =  false )
;    [set pcolor 20]]
  
  foreach gis:feature-list-of points
  [ gis:set-drawing-color 69
   gis:fill ? 2.0] 
  

  
end

to plot-results
;=========================================================================   

; This sets the size of the City nodes during the simulation
     set total-size sum [prelim-size] of turtles
     ask turtles [set size ((prelim-size / total-size) * 500)]
     ask turtles [ set color [255 0 0 200]]


      ask links [
       ifelse cumulative-demand-flow < 1 [ hide-link]
       [set color scale-color 98 cumulative-demand-flow 0 300
       set thickness ( cumulative-demand-flow / 40 )]]
;=========================================================================
end

;; Helper procedure for looking up a node by node-id.
to-report get-node [id]
  report one-of turtles with [node-id = id]
end

;;;;;;;;;;;;;;;;;;;;;;;
;;; Main Procedure  ;;;
;;;;;;;;;;;;;;;;;;;;;;;



to go 
  
  

   ask turtles with [color = red ] [set my-transport-cost (my-transport-cost + my-transport-cost-old) 
   set transport-cost my-transport-cost ]


   ask turtles with [color = blue ] [set my-surplus-given (my-surplus-given + my-surplus-given-old) 
   set surplus-given my-surplus-given ]


   ask turtles with [color = blue ] [set my-surplus-given-rome (my-surplus-given-rome + my-surplus-given-rome-old) 
   set surplus-given-rome my-surplus-given-rome ]


   ask blue-links  [set my-demand-flow (my-demand-flow + demand-flow-old) 
   set cumulative-demand-flow my-demand-flow ]

   ask blue-links  [set my-demand-flow-rome (my-demand-flow-rome + demand-flow-rome-old) 
   set cumulative-demand-flow-rome my-demand-flow-rome ]
   
   ask turtles with [color = blue ] [set my-surplus-given-antioch (my-surplus-given-antioch + my-surplus-given-antioch-old) 
   set surplus-given-antioch my-surplus-given-antioch ]

   ask blue-links  [set my-demand-flow-antioch (my-demand-flow-antioch + demand-flow-antioch-old) 
   set cumulative-demand-flow-antioch my-demand-flow-antioch ]
   
   ask turtles with [color = blue ] [set my-surplus-given-ephesus (my-surplus-given-ephesus + my-surplus-given-ephesus-old) 
   set surplus-given-ephesus my-surplus-given-ephesus ]

   ask blue-links  [set my-demand-flow-ephesus (my-demand-flow-ephesus + demand-flow-ephesus-old) 
   set cumulative-demand-flow-ephesus my-demand-flow-ephesus ]
   
   
      if ticks > 0 [
   
   set total-consumed (total-consumed + total-consumption-old) 
   set total-consumed-total total-consumed / ticks]
   
      if ticks = 0 [
   
   set total-consumed (total-consumed + total-consumption-old) 
   set total-consumed-total total-consumed ]
      
      if ticks > 0 [
   
   set total-exported (total-exported + total-production-old) 
   set total-exported-total total-exported / ticks] 


      if ticks = 0 [
   
   set total-exported (total-exported + total-production-old) 
   set total-exported-total total-exported ] 


  if ticks > 0 [
    set lost-in-transport  ((total-exported - total-consumed) / total-consumed)]



  ;link statistics
   ask turtles with [my-in-links = true] [set total-incomming-cost sum [cost] of my-in-links]
   ask turtles with [my-in-links = true] [set min-incomming-cost min [cost] of my-in-links]
   ask turtles with [my-in-links = true] [set max-incomming-cost max [cost] of my-in-links]
   
   ask turtles [ifelse count my-in-links > 1 
   [set std-incomming-cost standard-deviation [cost] of my-in-links]
   [set std-incomming-cost 1]]
   
   
   ask turtles [set val-last val]

 ; displays average cost of VW redistribution or source sink calculations
   
if ticks > 1 [
   link-visuals 
;  visuals ;Shows the relative size of the surplus and deficit of each city region
  cost-visuals; Shows the cumulative relative cost to import and the cumulative relative amount exported
 
  initiate-vals]
  
  ; calculates minimum cost distance from surplus to deficit nodes. This
  ; is used to calculate the cost of satifistying demand
    
  give-costs
   demand-costs


  
  ; calculates minimum cost distance from deficit to surplus nodes. This
  ; is used to determine the minimum cost path to attain virtual water
 

  
  ;Calculates the demand at each node and sends it along the minimum 
  ;cost path
  
  ifelse ticks < 500 [repeat 2 [demand-from]]
  
  [ifelse ticks < 3000 [repeat 3 [demand-from]]
    [ifelse ticks < 4000 [repeat 4 [demand-from]]
      [repeat 5 [demand-from]]]]



  ; Takes away demands from surplus nodes and redistributes it to deficit nodes.

  totting-up
   
   ask turtles with [ color = red] [ set my-transport-cost-old my-cost-to-blue]
   ask turtles with [color = blue] [ set my-surplus-given-old demand-on-me]
   ask turtles with [color = blue] [ set my-surplus-given-rome-old rome-demand-on-me]
      ask turtles with [color = blue] [ set my-surplus-given-antioch-old antioch-demand-on-me]
         ask turtles with [color = blue] [ set my-surplus-given-ephesus-old ephesus-demand-on-me]
   ask links [ set demand-flow-old demand-flow]
   ask links [ set demand-flow-rome-old demand-flow-rome]
   ask links [ set demand-flow-antioch-old demand-flow-antioch]
   ask links [ set demand-flow-ephesus-old demand-flow-ephesus]

   set total-consumption-old sum [my-receipt] of turtles with [color = red]
   set total-production-old sum [demand-on-me] of turtles with [color = blue]

 ; updates global variables and visuals
     update-globals

     
;     ;;; when all deficits or surplus are gone stop
;       if not any? turtles with [color = red] [write-output stop]
;       if not any? turtles with [color = blue] [write-output stop]

; when all deficits or surplus are gone stop
       if not any? turtles with [color = red] [ stop]
       if not any? turtles with [color = blue] [ stop]

reporters



  
  
  

     tick

end

;-----------------------------------------------------------------------------------------------------

; This is where the costs are calculated
to demand-costs
  repeat 1 [
  repeat 2 [
     ask turtles [
if color = red [ 
 if any? cost-from-blue-in-links [
        ; calculate minimum cost to blue by retracing back cost from blue
    set my-cost-to-blue my-cost-from-blue 
    ask min-cost-from-blue-link [ set other-end-min-cost end1] 
    set cost-to-blue-node [other-end-min-cost] of min-cost-from-blue-link
    set min-cost-to-blue-link out-link-to cost-to-blue-node
    ask min-cost-to-blue-link  [set cost-to-blue [my-cost-to-blue] of end1]]]]]

repeat 2 [
   ask turtles [
if color = black [
  if any? cost-from-blue-in-links [
   ; calculate minimum cost to blue by retracing back cost from blue
    set my-cost-to-blue my-cost-from-blue 
    set min-cost-from-blue-link min-one-of cost-from-blue-in-links [cost-from-blue]
    ask min-cost-from-blue-link [ set other-end-min-cost end1]
    set cost-to-blue-node [other-end-min-cost] of min-cost-from-blue-link
    set min-cost-to-blue-link out-link-to cost-to-blue-node
    ask min-cost-to-blue-link  [set cost-to-blue [my-cost-to-blue] of end1]]]]]

    
    repeat 2 [
   ask turtles [
if color = orange [ 
  if any? cost-from-blue-in-links [
    ; calculate minimum cost to blue by retracing back cost from blue
    set my-cost-to-blue my-cost-from-blue 
    ask min-cost-from-blue-link [ set other-end-min-cost end1]
    set cost-to-blue-node [other-end-min-cost] of min-cost-from-blue-link
    set min-cost-to-blue-link out-link-to cost-to-blue-node
    ask min-cost-to-blue-link [set cost-to-blue [my-cost-to-blue] of end1]]]]]
  
  
       

repeat 2 [
   ask turtles [
if color = blue [
  ; calculate minimum cost to blue by retracing back cost from blue
  set cost-to-blue-in-links my-in-links with [cost-to-blue > 0] 
  if any? cost-to-blue-in-links [
      set my-cost-to-blue [cost-to-blue] of min-one-of cost-to-blue-in-links [cost-to-blue]]]]]

   ]
  
  repeat 2 [
  ask turtles [ 
     set demand-out-links my-out-links with [ cost-to-blue > 0] ; the links sending out demand 
     set surplus-in-links my-in-links with [cost-from-blue > 0] ; the links bringing surplus
     set demand-in-links my-in-links with [cost-to-blue > 0]   ;the links bringing demand
  ]]
      end


to give-costs
 repeat 2 [
 repeat 2[
    
    ask turtles [
if color = blue [ 
    set my-cost-from-blue 0
    ask my-out-links [ set cost-from-blue ([my-cost-from-blue] of end1) + cost]]]] ;ask links to blue nodes set cost from blue their own cost


repeat 2 [
   ask turtles [
if color = black [
  

  set cost-from-blue-in-links my-in-links with [cost-from-blue > 0] 
  
  if any? cost-from-blue-in-links [
        
        set min-cost-from-blue-link min-one-of cost-from-blue-in-links [cost-from-blue] ;find in-links with minimum distance to blue
        set my-cost-from-blue [cost-from-blue] of min-cost-from-blue-link ; set my cost to blue the cost of the minimum distance link
    
        ask min-cost-from-blue-link [ set other-end-bogey end1] 
        set cost-from-blue-out-bogey-node [other-end-bogey] of min-cost-from-blue-link
        set cost-from-blue-out-bogey-link out-link-to cost-from-blue-out-bogey-node 
        ask cost-from-blue-out-bogey-link [set s_bogey 1] ; makes an out-link in the direction of the minimum cost to blue
        
        set cost-from-blue-out-links my-out-links with [s_bogey = 0] ;excludes the minimum cost link to avoid retracing ones tracks
        ask cost-from-blue-out-links [set cost-from-blue [my-cost-from-blue] of end1 + cost]]]]] ; sets cost to blue of the other out-links
    
      
    
repeat 2 [
   ask turtles [
if color = orange [ 
  
  set cost-from-blue-in-links my-in-links with [cost-from-blue > 0] 
  
  if any? cost-from-blue-in-links [
    
        set min-cost-from-blue-link min-one-of cost-from-blue-in-links [cost-from-blue];find in-links with minimum distance to blue
        set my-cost-from-blue [cost-from-blue] of min-cost-from-blue-link ; set my cost to blue the cost of the minimum distance link
           
        ask min-cost-from-blue-link [ set other-end-bogey end1]
        set cost-from-blue-out-bogey-node [other-end-bogey] of min-cost-from-blue-link
        set cost-from-blue-out-bogey-link out-link-to cost-from-blue-out-bogey-node
        ask cost-from-blue-out-bogey-link [set s_bogey 1] ; makes an out-link in the direction of the minimum cost to blue
        
        set cost-from-blue-out-links my-out-links with [s_bogey = 0] ;excludes the minimum cost link to avoid retracing ones tracks
        ask cost-from-blue-out-links [set cost-from-blue [my-cost-from-blue] of end1 + cost]]]]] ; sets cost to blue of the other out-links
  

repeat 2 [
   ask turtles [
if color = red [

set cost-from-blue-in-links my-in-links with [cost-from-blue > 0] 
  if any? cost-from-blue-in-links [
      
        set min-cost-from-blue-link min-one-of cost-from-blue-in-links [cost-from-blue];find in-links with minimum distance to blue
        set my-cost-from-blue [cost-from-blue] of min-cost-from-blue-link ; set my cost to blue the cost of the minimum distance link
        
      
        ask min-cost-from-blue-link [ set other-end-bogey end1]
        set cost-from-blue-out-bogey-node [other-end-bogey] of min-cost-from-blue-link
        set cost-from-blue-out-bogey-link out-link-to cost-from-blue-out-bogey-node
        ask cost-from-blue-out-bogey-link  [set s_bogey 1] ; makes an out-link in the direction of the minimum cost to blue
        
        set cost-from-blue-out-links my-out-links with [s_bogey = 0] ;excludes the minimum cost link to avoid retracing ones tracks
        ask cost-from-blue-out-links [set cost-from-blue [my-cost-from-blue] of end1 + cost]]]]] ; sets cost to blue of the other out-links
]

 
 
end


;---------------------------------------------------------------------------------------------------------------------------------

; Here each city node with a deficit demands from its nearest neighbours with a surplus.
  to demand-from
   repeat 5[
  
       ask turtle 229 [
    set i-rome-demand-from-myself abs val-time-1 * ( diffusion-rate / 100000) ;My demand is based on my initial deficit/100000
   ]
   
   ask turtle 229 [
    set i-rome-demand  (i-rome-demand-from-myself) ; Demand of myself and my neighbors is added
    if any? demand-out-links [
         ask  min-cost-to-blue-link [ set demand-flow-rome [i-rome-demand] of end1] ; this demand is sent along the minimum cost path to a surplus node
         set rome-receipt i-demand-from-myself]]
      
      
             ask turtle 210 [
    set i-antioch-demand-from-myself abs val-time-1 * ( diffusion-rate / 100000) ;My demand is based on my initial deficit/100000
   ]
   
   ask turtle 210 [
    set i-antioch-demand  (i-antioch-demand-from-myself) ; Demand of myself and my neighbors is added
    if any? demand-out-links [
         ask  min-cost-to-blue-link [ set demand-flow-antioch [i-antioch-demand] of end1] ; this demand is sent along the minimum cost path to a surplus node
         set antioch-receipt i-demand-from-myself]]
   
          ask turtle 29 [
    set i-ephesus-demand-from-myself abs val-time-1 * ( diffusion-rate / 100000) ;My demand is based on my initial deficit/100000
   ]
   
   ask turtle 29 [
    set i-ephesus-demand  (i-ephesus-demand-from-myself) ; Demand of myself and my neighbors is added
    if any? demand-out-links [
         ask  min-cost-to-blue-link [ set demand-flow-ephesus [i-ephesus-demand] of end1] ; this demand is sent along the minimum cost path to a surplus node
         set ephesus-receipt i-demand-from-myself]]
   ]
   
   
   repeat 5[
   ask turtles [
     if color = red [
     
       
       if any? surplus-in-links [
         
         
       set i-demand-from-myself abs val-time-1 * ( diffusion-rate / 100000) ;My demand is based on my initial deficit/100000
      
       set demand-on-me sum [demand-flow] of my-in-links]
       
       if who != 229 [
       set rome-demand-on-me sum [demand-flow-rome] of my-in-links]
       
              if who != 210 [
       set antioch-demand-on-me sum [demand-flow-antioch] of my-in-links]
              
                     if who != 29 [
       set ephesus-demand-on-me sum [demand-flow-ephesus] of my-in-links]
       
       set cum_demand_on_me sum [my-demand-flow] of my-in-links]] ; if I'm located between nodes with demand and nodes with surplus, then their demand is added to mine
  
    
      ask turtles [
     if color = red [
     
       set i-demand ( demand-on-me + i-demand-from-myself ) ; Demand of myself and my neighbors is added
       if who != 229 [
       set i-rome-demand rome-demand-on-me]
              if who != 210 [
       set i-antioch-demand antioch-demand-on-me]
                     if who != 29 [
       set i-ephesus-demand ephesus-demand-on-me]
       
       
       
       
         if any? demand-out-links [
        ask  min-cost-to-blue-link [ set demand-flow [i-demand] of end1] ; this demand is sent along the minimum cost path to a surplus node
        if who != 229 [
        ask  min-cost-to-blue-link [ set demand-flow-rome [i-rome-demand] of end1]]
                if who != 210 [
        ask  min-cost-to-blue-link [ set demand-flow-antioch [i-antioch-demand] of end1]]
                        if who != 29 [
        ask  min-cost-to-blue-link [ set demand-flow-ephesus [i-ephesus-demand] of end1]]
        
        set my-receipt i-demand-from-myself
        
        ]]]]
      
      
 

  
         pass-through-demand
         pass-through-demand
         pass-through-demand

           
           

         
        repeat 2[
   ask turtles [
       if color = blue [
         set demand-on-me sum [demand-flow] of my-in-links
         set rome-demand-on-me sum [demand-flow-rome] of my-in-links   ; the demand on the surplus nodes is the sum of all inflowing demand from connected links
         set antioch-demand-on-me sum [demand-flow-antioch] of my-in-links
         set ephesus-demand-on-me sum [demand-flow-ephesus] of my-in-links ]]]

 end 


     
;----------------------------------------------------------------------------------------------

to pass-through-demand
  
   
   ask turtles [
     if color = black [
       if any? surplus-in-links[
       if any? cost-from-blue-in-links [
       set i-demand sum [demand-flow] of my-in-links ; the demand on this intermediate node is the sum of all inflowing demand from connected links
       set i-rome-demand sum [demand-flow-rome] of my-in-links 
              set i-antioch-demand sum [demand-flow-antioch] of my-in-links 
                     set i-ephesus-demand sum [demand-flow-ephesus] of my-in-links 
       ask min-cost-to-blue-link  [set demand-flow [i-demand] of end1] ;this demand is sent along the minimum cost path to a surplus node
       ask min-cost-to-blue-link  [set demand-flow-rome [i-rome-demand] of end1]
           ask min-cost-to-blue-link  [set demand-flow-antioch [i-antioch-demand] of end1] 
               ask min-cost-to-blue-link  [set demand-flow-ephesus [i-ephesus-demand] of end1] ]]]] ;this demand is sent along the minimum cost path to a surplus node
   
   ask turtles [
     if color = orange [
       if any? cost-from-blue-in-links [
       if any? surplus-in-links [
       set i-demand sum [demand-flow] of my-in-links ; the demand on this intermediate node is the sum of all inflowing demand from connected links
       set i-rome-demand sum [demand-flow-rome] of my-in-links 
              set i-antioch-demand sum [demand-flow-antioch] of my-in-links 
                     set i-ephesus-demand sum [demand-flow-ephesus] of my-in-links 
       ask min-cost-to-blue-link  [set demand-flow [i-demand] of end1] 
       ask min-cost-to-blue-link  [set demand-flow-rome [i-rome-demand] of end1] 
              ask min-cost-to-blue-link  [set demand-flow-antioch [i-antioch-demand] of end1] 
                     ask min-cost-to-blue-link  [set demand-flow-ephesus [i-ephesus-demand] of end1] ]]]] ;this demand is sent along the minimum cost path to a surplus node
        
end


   
;-----------------------------------------------------------------------------------------------------------------------------------------

;each iteration we do book-keeping to calculate what was given and what was received 

to totting-up
  
      ask turtles [
          if color = red [
            set new-val val-last + my-receipt]]
          ask turtles [
          if color = black [
            set new-val val-last]]
          ask turtles [
          if color = orange [
            set new-val val-last]]
          ask turtles [
          if color = blue [
            set new-val val-last - demand-on-me]]
          ask turtles [
           if color = green [
            set new-val val-last]]
          
          ask turtles [ set val new-val];     
        
   end



;----------------------------------------------------------------------------------------------------------------------------------        
;this part controls the visuals of the model        
to link-visuals
;  ask turtles [ update-node-appearance ]
 ask links [ if my-demand-flow = 0 [ hide-link]]
  ask links [ if my-demand-flow > 0 [ show-link  
;                                   set color scale-color 105 (cumulative-demand-flow / ( mean-cum-flow + 0.000001)) min-flow mean-flow 
                                   set thickness (cumulative-demand-flow / ((mean-flow + 0.0000000001) * 20)) ]]
    ask links [ if demand-flow > 0 [   set color scale-color 98 (cumulative-demand-flow / ( (mean-cum-flow / 2 )+ 0.00001)) 200 0 ]]
  ;  set color scale-color gray (demand-flow / (2 * mean-flow + 0.00001)) -0.4 1
end

to cost-visuals
  
  if ticks > 0 [
    ask turtles [

       if val > 1000 [set color blue]
      if val < -1000 [set color red] 
      if (val > -1000) and (val < 1000) [
        if count my-in-links < 2 [
        set color green
;        ask my-links [die]
       ]
              

        
        if count my-in-links = 2 [        
        set color black]
        if count my-in-links > 2[
          set color orange]]
                   
                    if color = red [

  set size (0.1 + 5 * sqrt (abs(transport-cost) / abs(total-transport-cost))) * 10]         
                    
                    if color = blue [

  set size (0.1 + 5 * sqrt (abs(surplus-given) / abs(total-surplus-given))) * 10]
                    
      if not any? in-link-neighbors and not any? out-link-neighbors [ set color green]]]
  
  ask turtles with [color = orange] [hide-turtle]
      ask turtles with [color = black] [hide-turtle]
  end

to visuals
    ask turtles [
;      set size 0.01
 set size 0.1 + 5 * sqrt ((abs(val) / abs(total-val)) * 1000)
       if val > 1000 [set color blue]
      if val < -1000 [set color red] 
      if (val > -1000) and (val < 1000) [
        if count my-in-links < 2 [
         
        set color green
;        ask my-links [die]
         set size 0.00001
       ]
        
        
        if count my-in-links = 2 [        
        set color black
        set size 0.00001]
        if count my-in-links > 2[
          set color orange
          set size 0.00001]]
      
      if not any? in-link-neighbors and not any? out-link-neighbors [ set color green]]
  end


;-----------------------------------------------------------------------------------------------------
to update-globals
  

  set max-val max [ val ] of turtles
  set mean-flow mean [cumulative-demand-flow] of blue-links
  set min-flow min [cumulative-demand-flow] of blue-links
  set network-surplus sum [val] of turtles with [color = blue]
  set network-demand sum [val] of turtles with [color = red]
  set mean-cum-flow mean [cumulative-demand-flow] of links
end


;-----------------------------------------------------------------------------------------
 to reporters

   set total-production sum [demand-on-me] of turtles with [color = blue]
   set total-consumption sum [my-receipt] of turtles with [color = red]
   set total-val sum [ val ] of turtles
   set total-transport-cost sum [transport-cost] of turtles with [color = red]
   set total-surplus-given sum [surplus-given] of turtles with [color = blue]
   set total-demand-flow sum [cumulative-demand-flow] of links

 end   



to initiate-vals
              
ask turtles  [ set my-receipt 0
              set demand-on-me 0
              set i-demand 0
              set i-rome-demand 0
              set i-antioch-demand 0
              set i-ephesus-demand 0
              set i-surplus 0
              set rome-demand-on-me 0
              set antioch-demand-on-me 0
              set ephesus-demand-on-me 0]
 ask links [set cost-to-red 0
            set cost-from-blue 0
            set surplus-flow 0
            set demand-flow 0
            set demand-flow-rome 0
            set demand-flow-antioch 0
            set demand-flow-ephesus 0
            set d_bogey 0
            set s_bogey 0]
 
 end
 
;--------------------------------------------------------------------------------------------------
; to reports
; 
;;    show [total-val] of turtle 0
;    show [(total-consumption - total-production)] of turtle 0
;    show [total-consumption] of turtle 0
;    show [total-production] of turtle 0
;    show count turtles with [color = red]
;    
; end
 ;-------------------------------------------------------------------------------------------------

;This looks up the attribute table of the point shapefile we imported with the city data
to import-gis-cities

   foreach gis:feature-list-of points
    [create-turtles 1 [
     set node-id gis:property-value ? "ID"
     
;depending on the climate in each year, it assigns different surplus and deficit values
     set val gis:property-value ? word "yr" year
     set val-time-1 gis:property-value ? word "yr" year
     let location gis:location-of (first (first (gis:vertex-lists-of ?)))
     set xcor item 0 location
     set ycor item 1 location
     ]]
    
;    let vaal-list (list([val-time-1] of turtles))
;    
;    set val-list one-of vaal-list
;    
;    ask turtles [set val one-of val-list]
;    ask turtles [set val-time-1 val]
;    
    end

to add_chandler_data
  
    ;Adjust city demand based on population values of Chandler 1974
    ask turtle 229 [set val (val - 94400000) ] ; Rome
        ask turtle 171 [set val (val - 61353000) ] ; Alexandria
            ask turtle 29 [set val (val - 35471200) ] ; Ephesus
                ask turtle 210 [set val (val - 25480000) ] ; Antioch
                    ask turtle 634 [set val (val - 20082800) ] ; Apamea
                        ask turtle 514 [set val (val - 14400000) ] ; Pergamum
                            ask turtle 293 [set val (val - 12224000) ] ; Cadiz
                                ask turtle 484 [set val (val - 7030400) ] ; Corinth
                                    ask turtle 426 [set val (val - 16362600) ] ; Sardis
                                        ask turtle 291 [set val (val - 16400000) ] ; Syracuse
                                            ask turtle 515 [set val (val - 15000000) ] ; Symrna
                                                ask turtle 337 [set val (val - 8000000) ] ; Cordova
                                                    ask turtle 628 [set val (val - 8000) ] ; Caesarea
                                                        ask turtle 646 [set val (val - 8800000) ] ; Volulibis
                                                            ask turtle 372 [set val (val - 7600000) ] ; Autun

                                                                        
      ask turtle 229 [set val-time-1 (val-time-1 - 94400000) ] ; Rome
        ask turtle 171 [set val-time-1 (val-time-1 - 61353000) ] ; Alexandria
            ask turtle 29 [set val-time-1 (val-time-1 - 35471200) ] ; Ephesus
                ask turtle 210 [set val-time-1 (val-time-1 - 25480000) ] ; Antioch
                    ask turtle 634 [set val-time-1 (val-time-1 - 20082800) ] ; Apamea
                        ask turtle 514 [set val-time-1 (val-time-1 - 14400000) ] ; Pergamum
                            ask turtle 293 [set val-time-1 (val-time-1 - 12224000) ] ; Cadiz
                                ask turtle 484 [set val-time-1 (val-time-1 - 7030400) ] ; Corinth
                                    ask turtle 426 [set val-time-1 (val-time-1 - 16362600) ] ; Sardis
                                        ask turtle 291 [set val-time-1 (val-time-1 - 16400000) ] ; Syracuse
                                            ask turtle 515 [set val-time-1 (val-time-1 - 15000000) ] ; Symrna
                                                ask turtle 337 [set val-time-1 (val-time-1 - 8000000) ] ; Cordova
                                                    ask turtle 628 [set val-time-1 (val-time-1 - 8000) ] ; Caesarea
                                                        ask turtle 646 [set val-time-1 (val-time-1 - 8800000) ] ; Volulibis
                                                            ask turtle 372 [set val-time-1 (val-time-1 - 7600000) ] ; Autun


ask turtles with [val < 0] [set val (val + (abs(val) * demand-gradient ))]
ask turtles with [val-time-1 < 0] [set val-time-1 (val-time-1 + (abs(val-time-1) * demand-gradient ))]
end
; this imports a file road_id_with_cost.txt that contains the IDs of each linked city and the cost of transport between them

to import-roman-roads
  ;; This opens the file, so we can use it.

  file-open "road_id_with_mean_cost.txt"
;  file-open "roman_roads_sum_cost.txt"
  ;; Read in all the data in the file
  while [not file-at-end?]
  [
    ;; this reads a single line into a three-item list
    let items read-from-string (word "[" file-read-line "]")
    ask get-node (item 0 items)
    [
      create-blue-link-to get-node (item 1 items)
        [ set link_id_1 item 0 items
          set link_id_2 item 1 items
          set cost item 2 items
          set cost1 item 2 items
;          set label item 2 items 
        
         ]
    ]
  ]
  
  file-close
  
end  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Sets link costs to random  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;    let coost-list (list([cost] of blue-links))
;    
;    set cost-list one-of coost-list
;    
;    ask blue-links [set cost one-of cost-list]
;    
;  file-close

;  



;----------------------------------------------------------------------------------------
;;;  If you want to write the output you need to set the directory and uncomment the following section


to write-output
let directory "C:\\Users\\Brian\\Documents\\phd\\virtual_water\\Netlogo\\other_computer\\demand_gradient\\"


file-open (word directory year "_" demand-gradient "_out.txt")
foreach sort turtles [
file-type [node-id] of ?
file-type ","
file-type [surplus-given] of ?
file-type ","
file-type [val-time-1] of ?
file-type ","
file-type [transport-cost] of ?
file-type ","
file-type [surplus-given-rome] of ?
file-type ","
file-type [surplus-given-antioch] of ?
file-type ","
file-type [surplus-given-ephesus] of ?
file-type ","
file-type [count my-in-links] of ?
file-type ","
file-type [ticks] of ?
file-type ","
file-type [total-incomming-cost] of ?
file-type ","
file-type [std-incomming-cost] of ?
file-type ","
file-type [min-incomming-cost] of ?
file-type ","
file-type [max-incomming-cost] of ?
file-type ","
file-print [lost-in-transport] of ?
]

foreach sort links [
ask ? [file-type [node-id] of end1 ]
file-type ","
ask ? [file-type [node-id] of end2 ]
file-type ","
file-type [cost] of ?
file-type ","
file-type [cumulative-demand-flow] of ?
file-type ","
file-type [cumulative-demand-flow-rome] of ?
file-type ","
file-type [cumulative-demand-flow-antioch] of ?
file-type ","
file-type [cumulative-demand-flow-ephesus] of ?
file-type ","
file-type [cost-to-red] of ?
file-type ","
file-type [cost-to-blue] of ?
file-type ","
file-type [cost-to-blue] of ?
file-type ","
file-type [cost-to-blue] of ?
file-type ","
file-type [cost-to-blue] of ?
file-type ","
file-type [cost-to-blue] of ?
file-type ","
file-print [cost-to-blue] of ?
]
file-close 
end

;-----------------------------------------------------------------------------------------------

  
@#$#@#$#@
GRAPHICS-WINDOW
210
10
1574
944
-1
-1
1.5
1
10
1
1
1
0
0
0
1
0
902
0
601
1
1
1
ticks
30.0

BUTTON
29
134
92
167
Go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
0

BUTTON
136
134
200
167
Setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
28
92
200
125
diffusion-rate
diffusion-rate
0
100
5
1
1
NIL
HORIZONTAL

PLOT
5
194
205
344
Network surplus and demand
Time
Amount
0.0
50.0
-2500.0
2500.0
true
false
"" ""
PENS
"default" 1.0 0 -2674135 true "" "plot network-demand"
"pen-1" 1.0 0 -16448764 true "" "plot network-surplus"

SLIDER
28
14
200
47
year
year
1949
2000
1958
1
1
NIL
HORIZONTAL

SLIDER
28
52
200
85
demand-gradient
demand-gradient
-0.9
0.9
0
0.1
1
NIL
HORIZONTAL

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="real_bs" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <steppedValueSet variable="year" first="1949" step="1" last="2000"/>
  </experiment>
  <experiment name="experiment" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <enumeratedValueSet variable="diffusion-rate">
      <value value="5"/>
    </enumeratedValueSet>
    <steppedValueSet variable="year" first="1988" step="1" last="2000"/>
  </experiment>
  <experiment name="demand_gradient" repetitions="1" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <steppedValueSet variable="year" first="1949" step="1" last="2000"/>
    <enumeratedValueSet variable="diffusion-rate">
      <value value="5"/>
    </enumeratedValueSet>
    <steppedValueSet variable="demand-gradient" first="-0.5" step="0.1" last="0.5"/>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

brian
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
false
14
Line -7500403 false 150 150 90 180
Line -7500403 false 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
